1 # SPDX-License-Identifier: GPL-2.0-only
2 # Makefile for the different targets used to generate full packages of a kernel
4 include $(srctree)/scripts/Kbuild.include
5 include $(srctree)/scripts/Makefile.lib
7 KERNELPATH := kernel-$(subst -,_,$(KERNELRELEASE))
8 # Include only those top-level files that are needed by make, plus the GPL copy
9 TAR_CONTENT := Documentation LICENSES arch block certs crypto drivers fs \
10 include init io_uring ipc kernel lib mm net rust \
11 samples scripts security sound tools usr virt \
13 Kbuild Kconfig COPYING $(wildcard localversion*)
15 quiet_cmd_src_tar = TAR $(2).tar.gz
17 if test "$(objtree)" != "$(srctree)"; then \
20 echo >&2 " Building source tarball is not possible outside the"; \
21 echo >&2 " kernel source tree. Don't set KBUILD_OUTPUT"; \
25 tar -I $(KGZIP) -c $(RCS_TAR_IGNORE) -f $(2).tar.gz \
26 --transform 's:^:$(2)/:S' $(TAR_CONTENT) $(3)
29 # ---------------------------------------------------------------------------
31 filechk_HEAD = git -C $(srctree) rev-parse --verify HEAD 2>/dev/null
33 .tmp_HEAD: check-git FORCE
38 @if ! $(srctree)/scripts/check-git; then \
39 echo >&2 "error: creating source package requires git repository"; \
43 git-config-tar.gz = -c tar.tar.gz.command="$(KGZIP)"
44 git-config-tar.bz2 = -c tar.tar.bz2.command="$(KBZIP2)"
45 git-config-tar.lzma = -c tar.tar.lzma.command="$(LZMA)"
46 git-config-tar.xz = -c tar.tar.xz.command="$(XZ)"
47 git-config-tar.zst = -c tar.tar.zst.command="$(ZSTD)"
49 quiet_cmd_archive = ARCHIVE $@
50 cmd_archive = git -C $(srctree) $(git-config-tar$(suffix $@)) archive \
51 --output=$$(realpath $@) $(archive-args)
58 # Linux source tarball
59 # ---------------------------------------------------------------------------
61 linux-tarballs := $(addprefix linux, .tar.gz .tar.bz2 .tar.lzma .tar.xz)
63 targets += $(linux-tarballs)
64 $(linux-tarballs): archive-args = --prefix=linux/ $$(cat $<)
65 $(linux-tarballs): .tmp_HEAD FORCE
66 $(call if_changed,archive)
68 # rpm-pkg srcrpm-pkg binrpm-pkg
69 # ---------------------------------------------------------------------------
71 quiet_cmd_mkspec = GEN $@
72 cmd_mkspec = $(srctree)/scripts/package/mkspec > $@
78 rpm-sources: linux.tar.gz
79 $(Q)mkdir -p rpmbuild/SOURCES
80 $(Q)ln -f linux.tar.gz rpmbuild/SOURCES/linux.tar.gz
81 $(Q)cp $(KCONFIG_CONFIG) rpmbuild/SOURCES/config
82 $(Q)$(srctree)/scripts/package/gen-diff-patch rpmbuild/SOURCES/diff.patch
84 PHONY += rpm-pkg srcrpm-pkg binrpm-pkg
86 rpm-pkg: private build-type := a
87 srcrpm-pkg: private build-type := s
88 binrpm-pkg: private build-type := b
90 rpm-pkg srcrpm-pkg: rpm-sources
91 rpm-pkg srcrpm-pkg binrpm-pkg: kernel.spec
92 +$(strip rpmbuild -b$(build-type) kernel.spec \
93 --define='_topdir $(abspath rpmbuild)' \
94 $(if $(filter a b, $(build-type)), \
95 --target $(UTS_MACHINE)-linux --build-in-place --noprep --define='_smp_mflags %{nil}' \
96 $$(rpm -q rpm >/dev/null 2>&1 || echo --nodeps)) \
97 $(if $(filter b, $(build-type)), \
101 # deb-pkg srcdeb-pkg bindeb-pkg
102 # ---------------------------------------------------------------------------
104 KDEB_SOURCE_COMPRESS ?= gzip
106 supported-deb-source-compress := gzip bzip2 lzma xz
108 PHONY += linux.tar.unsupported-deb-src-compress
109 linux.tar.unsupported-deb-src-compress:
110 @echo "error: KDEB_SOURCE_COMPRESS=$(KDEB_SOURCE_COMPRESS) is not supported. The supported values are: $(supported-deb-source-compress)" >&2
113 debian-orig-suffix := \
114 $(strip $(if $(filter $(supported-deb-source-compress), $(KDEB_SOURCE_COMPRESS)), \
115 $(suffix-$(KDEB_SOURCE_COMPRESS)),.unsupported-deb-src-compress))
117 quiet_cmd_debianize = GEN $@
118 cmd_debianize = $(srctree)/scripts/package/mkdebian $(mkdebian-opts)
121 $(call cmd,debianize)
124 debian-orig: private source = $(shell dpkg-parsechangelog -S Source)
125 debian-orig: private version = $(shell dpkg-parsechangelog -S Version | sed 's/-[^-]*$$//')
126 debian-orig: private orig-name = $(source)_$(version).orig.tar$(debian-orig-suffix)
127 debian-orig: mkdebian-opts = --need-source
128 debian-orig: linux.tar$(debian-orig-suffix) debian
129 $(Q)if [ "$(df --output=target .. 2>/dev/null)" = "$(df --output=target $< 2>/dev/null)" ]; then \
130 ln -f $< ../$(orig-name); \
132 cp $< ../$(orig-name); \
135 KBUILD_PKG_ROOTCMD ?= 'fakeroot -u'
137 PHONY += deb-pkg srcdeb-pkg bindeb-pkg
139 deb-pkg: private build-type := source,binary
140 srcdeb-pkg: private build-type := source
141 bindeb-pkg: private build-type := binary
143 deb-pkg srcdeb-pkg: debian-orig
145 deb-pkg srcdeb-pkg bindeb-pkg:
146 +$(strip dpkg-buildpackage \
147 --build=$(build-type) --no-pre-clean --unsigned-changes \
148 $(if $(findstring source, $(build-type)), \
149 --unsigned-source --compression=$(KDEB_SOURCE_COMPRESS)) \
150 $(if $(findstring binary, $(build-type)), \
151 --rules-file='$(MAKE) -f debian/rules' --jobs=1 -r$(KBUILD_PKG_ROOTCMD) -a$$(cat debian/arch), \
152 --no-check-builddeps) \
156 # ---------------------------------------------------------------------------
159 rm -rf $(objtree)/snap
160 mkdir $(objtree)/snap
162 $(call cmd,src_tar,$(KERNELPATH))
163 sed "s@KERNELRELEASE@$(KERNELRELEASE)@; \
164 s@SRCTREE@$(shell realpath $(KERNELPATH).tar.gz)@" \
165 $(srctree)/scripts/package/snapcraft.template > \
166 $(objtree)/snap/snapcraft.yaml
167 cd $(objtree)/snap && \
168 snapcraft --target-arch=$(UTS_MACHINE)
170 # dir-pkg tar*-pkg - tarball targets
171 # ---------------------------------------------------------------------------
174 $(Q)$(MAKE) -f $(srctree)/Makefile
175 +$(Q)$(srctree)/scripts/package/buildtar $@
177 compress-tar.gz = -I "$(KGZIP)"
178 compress-tar.bz2 = -I "$(KBZIP2)"
179 compress-tar.xz = -I "$(XZ)"
180 compress-tar.zst = -I "$(ZSTD)"
182 quiet_cmd_tar = TAR $@
183 cmd_tar = cd $<; tar cf ../$@ $(compress-tar$(suffix $@)) --owner=root --group=root --sort=name *
185 dir-tarballs := $(addprefix linux-$(KERNELRELEASE)-$(ARCH), .tar .tar.gz .tar.bz2 .tar.xz .tar.zst)
187 $(dir-tarballs): tar-install
192 @echo "Kernel tree successfully created in $<"
195 tar-pkg: linux-$(KERNELRELEASE)-$(ARCH).tar
198 tar%-pkg: linux-$(KERNELRELEASE)-$(ARCH).tar.% FORCE
201 # perf-tar*-src-pkg - generate a source tarball with perf source
202 # ---------------------------------------------------------------------------
207 .tmp_perf/HEAD: .tmp_HEAD | .tmp_perf
210 quiet_cmd_perf_version_file = GEN $@
211 cmd_perf_version_file = cd $(srctree)/tools/perf; util/PERF-VERSION-GEN $(dir $(abspath $@))
213 # PERF-VERSION-FILE and .tmp_HEAD are independent, but this avoids updating the
214 # timestamp of PERF-VERSION-FILE.
215 # The best is to fix tools/perf/util/PERF-VERSION-GEN.
216 .tmp_perf/PERF-VERSION-FILE: .tmp_HEAD $(srctree)/tools/perf/util/PERF-VERSION-GEN | .tmp_perf
217 $(call cmd,perf_version_file)
219 perf-archive-args = --add-file=$$(realpath $(word 2, $^)) \
220 --add-file=$$(realpath $(word 3, $^)) \
221 $$(cat $(word 2, $^))^{tree} $$(cat $<)
224 perf-tarballs := $(addprefix perf-$(KERNELVERSION), .tar .tar.gz .tar.bz2 .tar.xz .tar.zst)
226 targets += $(perf-tarballs)
227 $(perf-tarballs): archive-args = --prefix=perf-$(KERNELVERSION)/ $(perf-archive-args)
228 $(perf-tarballs): tools/perf/MANIFEST .tmp_perf/HEAD .tmp_perf/PERF-VERSION-FILE FORCE
229 $(call if_changed,archive)
231 PHONY += perf-tar-src-pkg
232 perf-tar-src-pkg: perf-$(KERNELVERSION).tar
235 perf-tar%-src-pkg: perf-$(KERNELVERSION).tar.% FORCE
238 # Help text displayed when executing 'make help'
239 # ---------------------------------------------------------------------------
242 @echo ' rpm-pkg - Build both source and binary RPM kernel packages'
243 @echo ' srcrpm-pkg - Build only the source kernel RPM package'
244 @echo ' binrpm-pkg - Build only the binary kernel RPM package'
245 @echo ' deb-pkg - Build both source and binary deb kernel packages'
246 @echo ' srcdeb-pkg - Build only the source kernel deb package'
247 @echo ' bindeb-pkg - Build only the binary kernel deb package'
248 @echo ' snap-pkg - Build only the binary kernel snap package'
249 @echo ' (will connect to external hosts)'
250 @echo ' dir-pkg - Build the kernel as a plain directory structure'
251 @echo ' tar-pkg - Build the kernel as an uncompressed tarball'
252 @echo ' targz-pkg - Build the kernel as a gzip compressed tarball'
253 @echo ' tarbz2-pkg - Build the kernel as a bzip2 compressed tarball'
254 @echo ' tarxz-pkg - Build the kernel as a xz compressed tarball'
255 @echo ' tarzst-pkg - Build the kernel as a zstd compressed tarball'
256 @echo ' perf-tar-src-pkg - Build the perf source tarball with no compression'
257 @echo ' perf-targz-src-pkg - Build the perf source tarball with gzip compression'
258 @echo ' perf-tarbz2-src-pkg - Build the perf source tarball with bz2 compression'
259 @echo ' perf-tarxz-src-pkg - Build the perf source tarball with xz compression'
260 @echo ' perf-tarzst-src-pkg - Build the perf source tarball with zst compression'
265 # Read all saved command lines and dependencies for the $(targets) we
266 # may be building above, using $(if_changed{,_dep}). As an
267 # optimization, we don't need to read them if the target does not
268 # exist, we will rebuild anyway in that case.
270 existing-targets := $(wildcard $(sort $(targets)))
272 -include $(foreach f,$(existing-targets),$(dir $(f)).$(notdir $(f)).cmd)